
// bright		by plum

// mod			by hiroi01


// wb_[
#include <pspkernel.h>
#include <pspdisplay_kernel.h>
#include <string.h>
#include <systemctrl.h>
#include "conf.h"
#include "memory.h"

// ݒ
PSP_MODULE_INFO("bright", 0x1000, 0, 1);

// `
#define MAKE_CALL(a, f) _sw(0x0C000000 | (((u32)(f) >> 2) & 0x03FFFFFF), a);
#define PSP_FIRMWARE(f) ((((f >> 8) & 0xF) << 24) | (((f >> 4) & 0xF) << 16) | ((f & 0xF) << 8) | 0x10)

// O[oϐ
Bright *bright_buf = NULL;
int bright_count = 0;
int position = 0;
STMOD_HANDLER previous;

// ֐
void ClearCaches()
{
	sceKernelDcacheWritebackAll();
	sceKernelIcacheClearAll();
}

int GetPatchAddr(u32 text_addr, u32 text_end, u32 *addr)
{

	// pb`AhXT ̒T͂܂Ȃ
	for(; text_addr < text_end; text_addr += 4)
	{
		if(
			_lw(text_addr     ) == 0x8FBF0000 &&
			_lw(text_addr +  4) == 0x00801021 &&
			_lw(text_addr +  8) == 0x03E00008 &&
			_lw(text_addr + 12) == 0x27BD0010
		)
		{
			*addr = (text_addr - 12);
			return 0;
		}
	}
	
	//not found
	return -1;
}


// pb`֐
void sceDisplaySetBrightnessPatched(int level, int unk1)
{

	// PxZbg
	sceDisplaySetBrightness(bright_buf[position].level, 0);

	// ̈ʒu
	position++;
	if(position > (bright_count - 1)) position = 0;
}

int OnModuleStart(SceModule2 *mod)
{
	if(strcmp(mod->modname, "sceDisplay_Service") == 0) {
		u32 patch_addr;
		// pb`AhX擾
		if( GetPatchAddr(mod->text_addr, mod->text_addr + mod->text_size, &patch_addr) == 0){ 
			// pb`
			MAKE_CALL( patch_addr, sceDisplaySetBrightnessPatched);
			// LbVNA
			ClearCaches();
		}
	}

	return previous ? previous(mod) : 0;
}

// Gg[|Cg
int module_start(SceSize args, void *argp)
{
	u32 patch_addr;
	char path[256];
	SceModule2 *mod;

	// pX
	strcpy(path, (char *)argp);
	GetConfigPath(path);

	// JEg
	bright_count = CountItem(path);
	if(bright_count <= 0) return -1;

	// m J[l̈悩mۂĂ̂?
	bright_buf = (Bright *)memoryAllocEx( "ms_malloc", MEMORY_KERN_HI, 0, sizeof(Bright) * bright_count, PSP_SMEM_Low, NULL );
	if(!bright_buf) return -1;
	
	// ݒt@Cǂݍ
	ReadItem(path, bright_buf);
	
	// W[
	mod = (SceModule2 *)sceKernelFindModuleByName("sceDisplay_Service");
	if( mod == NULL ) return -1;

	// pb`AhX擾
	if( GetPatchAddr(mod->text_addr, mod->text_addr + mod->text_size, &patch_addr) == 0){ 
		// pb`
		MAKE_CALL( patch_addr, sceDisplaySetBrightnessPatched);
		// LbVNA
		ClearCaches();
	}else{
		previous = sctrlHENSetStartModuleHandler(OnModuleStart);
	}
	
	return 0;
}

int module_stop(SceSize args, void *argp)
{
	memoryFree(bright_buf);
    return 0;
}


